package cn.iocoder.yudao.module.mes.service.bom;

import cn.iocoder.yudao.framework.test.core.ut.BaseDbAndRedisUnitTest;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import cn.iocoder.yudao.framework.test.core.ut.BaseDbUnitTest;

import cn.iocoder.yudao.module.mes.controller.admin.bom.vo.*;
import cn.iocoder.yudao.module.mes.dal.dataobject.bom.BomDO;
import cn.iocoder.yudao.module.mes.dal.mysql.bom.BomMapper;
import cn.iocoder.yudao.framework.common.pojo.PageResult;

import org.springframework.context.annotation.Import;

import javax.annotation.Resource;
import java.util.*;
import java.time.LocalDateTime;

import static cn.hutool.core.util.RandomUtil.*;
import static cn.iocoder.yudao.module.mes.enums.ErrorCodeConstants.*;
import static cn.iocoder.yudao.framework.test.core.util.AssertUtils.*;
import static cn.iocoder.yudao.framework.test.core.util.RandomUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.LocalDateTimeUtils.*;
import static cn.iocoder.yudao.framework.common.util.object.ObjectUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.DateUtils.*;
import static org.junit.jupiter.api.Assertions.*;
import static org.mockito.Mockito.*;

/**
 * {@link BomServiceImpl} 的单元测试类
 *
 * @author 内蒙必硕
 */
@Import(BomServiceImpl.class)
public class BomServiceImplTest extends BaseDbAndRedisUnitTest {

    @Resource
    private BomServiceImpl bomService;

    @Resource
    private BomMapper bomMapper;

    @Test
    public void testCreateBom_success() {
        // 准备参数
        BomSaveReqVO createReqVO = randomPojo(BomSaveReqVO.class).setId(null);

        // 调用
        Long bomId = bomService.createBom(createReqVO);
        // 断言
        assertNotNull(bomId);
        // 校验记录的属性是否正确
        BomDO bom = bomMapper.selectById(bomId);
        assertPojoEquals(createReqVO, bom, "id");
    }

    @Test
    public void testUpdateBom_success() {
        // mock 数据
        BomDO dbBom = randomPojo(BomDO.class);
        bomMapper.insert(dbBom);// @Sql: 先插入出一条存在的数据
        // 准备参数
        BomSaveReqVO updateReqVO = randomPojo(BomSaveReqVO.class, o -> {
            o.setId(dbBom.getId()); // 设置更新的 ID
        });

        // 调用
        bomService.updateBom(updateReqVO);
        // 校验是否更新正确
        BomDO bom = bomMapper.selectById(updateReqVO.getId()); // 获取最新的
        assertPojoEquals(updateReqVO, bom);
    }

    @Test
    public void testUpdateBom_notExists() {
        // 准备参数
        BomSaveReqVO updateReqVO = randomPojo(BomSaveReqVO.class);

        // 调用, 并断言异常
        assertServiceException(() -> bomService.updateBom(updateReqVO), BOM_NOT_EXISTS);
    }

    @Test
    public void testDeleteBom_success() {
        // mock 数据
        BomDO dbBom = randomPojo(BomDO.class);
        bomMapper.insert(dbBom);// @Sql: 先插入出一条存在的数据
        // 准备参数
        Long id = dbBom.getId();

        // 调用
        bomService.deleteBom(id);
       // 校验数据不存在了
       assertNull(bomMapper.selectById(id));
    }

    @Test
    public void testDeleteBom_notExists() {
        // 准备参数
        Long id = randomLongId();

        // 调用, 并断言异常
        assertServiceException(() -> bomService.deleteBom(id), BOM_NOT_EXISTS);
    }

    @Test
    @Disabled  // TODO 请修改 null 为需要的值，然后删除 @Disabled 注解
    public void testGetBomPage() {
       // mock 数据
       BomDO dbBom = randomPojo(BomDO.class, o -> { // 等会查询到
           o.setCode(null);
           o.setVersion(null);
           o.setProductId(null);
           o.setUnitId(null);
           o.setYieldRate(null);
           o.setRemark(null);
           o.setIsEnable(null);
           o.setCreateTime(null);
       });
       bomMapper.insert(dbBom);
       // 测试 code 不匹配
       bomMapper.insert(cloneIgnoreId(dbBom, o -> o.setCode(null)));
       // 测试 version 不匹配
       bomMapper.insert(cloneIgnoreId(dbBom, o -> o.setVersion(null)));
       // 测试 productId 不匹配
       bomMapper.insert(cloneIgnoreId(dbBom, o -> o.setProductId(null)));
       // 测试 unitId 不匹配
       bomMapper.insert(cloneIgnoreId(dbBom, o -> o.setUnitId(null)));
       // 测试 yieldRate 不匹配
       bomMapper.insert(cloneIgnoreId(dbBom, o -> o.setYieldRate(null)));
       // 测试 remark 不匹配
       bomMapper.insert(cloneIgnoreId(dbBom, o -> o.setRemark(null)));
       // 测试 isEnable 不匹配
       bomMapper.insert(cloneIgnoreId(dbBom, o -> o.setIsEnable(null)));
       // 测试 createTime 不匹配
       bomMapper.insert(cloneIgnoreId(dbBom, o -> o.setCreateTime(null)));
       // 准备参数
       BomPageReqVO reqVO = new BomPageReqVO();
       reqVO.setCode(null);
       reqVO.setVersion(null);
       reqVO.setProductId(null);
       reqVO.setUnitId(null);
       reqVO.setYieldRate(null);
       reqVO.setRemark(null);
       reqVO.setIsEnable(null);
       reqVO.setCreateTime(buildBetweenTime(2023, 2, 1, 2023, 2, 28));

       // 调用
       PageResult<BomRespVO> pageResult = bomService.getBomPage(reqVO);
       // 断言
       assertEquals(1, pageResult.getTotal());
       assertEquals(1, pageResult.getList().size());
       assertPojoEquals(dbBom, pageResult.getList().get(0));
    }

}